/*
 * Main.java
 *
 * Created on 21. listopad 2006, 19:56
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package osmdam;

import java.util.Comparator;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.Random;
import java.util.Set;
import java.util.TreeSet;

/**
 *
 * @author pirko
 */
public class Main {
    
    private Set<State> history = new TreeSet<State>(new Comparator() {
         public int compare(Object state1, Object state2) {
            if (state1 == null) return Integer.MAX_VALUE;
            if (state2 == null) return Integer.MIN_VALUE;
            return state1.equals(state2) ? 0 : -1;
        }
    });
    Random random = new Random();
    
    /** Creates a new instance of Main */
    public Main() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        System.out.println("\n#################### Ze zadani:");
        Main main = new Main();
        main.hillClimbing(new State(State.Type.DEFAULT)); // defaultni ze zadani
        
        System.out.println("\n#################### Jeden konflikty:");
        Main soft = new Main();
        soft.hillClimbing(new State(State.Type.SOFT));
        
        // Nasledujici radky je mozne odkomentovat pro vyzkouseni velmi texkeho zadani
        
        System.out.println("\n#################### Tri konflikty:");
        Main hard = new Main();
        hard.hillClimbing(new State(State.Type.HARD)); // njtezsi
        
        System.out.println("\n#################### Nahodne:");
        Main gen = new Main();
        gen.hillClimbing(new State(State.Type.GEN)); // njtezsi
        
    }
    
    public void hillClimbing(State start) {
        history.add(start);
        
        System.out.println("START hill climbing:");
        start.print();
        System.out.print("\n");
        System.out.println("První hodnota: "+start.value());
       
       
        State current = start;
        
        do {
            State next = chooseNext(current);
            
            if (next == null || next.value() == current.value()) {
                System.out.println("Koncime splhani s vysledkem:");
                current.print();
                System.out.println(current.isSolution() ? "Nalezli jsme reseni!" : 
                    "Uvaznuti s hodnotou: "+current.value());
                break;
            }
            
//            next.print();
//            System.out.print(next.value()+"\n");
                    
            
            current = next;
            history.add(current);
        } while(true);
    }
    
    private State chooseNext(State state) {
        List<State> nexts = state.getNext(); // jiz vraci pouze nejlepsi stavy
        if (nexts.size() > 1) {            
            int r = random.nextInt(nexts.size());
            return nexts.get(r);            
        } else if (nexts.size() == 1) {
            return nexts.get(0);
        } else
            return null;
    }
    
}
